#ifndef TAB_H
#define TAB_H

//Base Tab class from which all tabs are derived

class Tab
{
public:
	Tab() {}
	virtual ~Tab() {}

	HWND getHandle(void);

	virtual void clearImage(void) = 0;
	virtual void create(void) = 0;
	virtual void exportImage(void) = 0;
	virtual void flipImage(int) = 0;
	void hide(void);
	virtual void import(void) = 0;
	virtual void initTab(void) = 0;
	void invalidateTab(void);
	virtual void newROM(void);
	bool save(char* filename)
	{
		if (hasChanged())
		{
			m_changed = false;
			return save_internal(filename);
		}

		return true;
	}
	
	void show(void);
	bool hasChanged() { return m_changed; }
protected:

	HWND hTab;
	bool m_changed = false;

	virtual void drawTab(void) = 0;
	void invalidateTabControl(int);

	virtual BOOL tabProc(HWND, UINT, WPARAM, LPARAM) = 0;

private:
	virtual bool save_internal(char* filename) = 0;
};

#endif

